'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d3Selection = require('d3-selection');

var _d3Zoom = require('d3-zoom');

var _simulation = require('./simulation');

var _simulation2 = _interopRequireDefault(_simulation);

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

var _link = require('./link');

var _link2 = _interopRequireDefault(_link);

var _layout2 = require('./layout');

var _layout3 = _interopRequireDefault(_layout2);

var _minBy2 = require('lodash/minBy');

var _minBy3 = _interopRequireDefault(_minBy2);

var _maxBy2 = require('lodash/maxBy');

var _maxBy3 = _interopRequireDefault(_maxBy2);

var _default = require('./default');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var D3ReactForce = function (_React$Component) {
  _inherits(D3ReactForce, _React$Component);

  // 保存hover边的dom
  // 保存节点的dom
  function D3ReactForce(props) {
    _classCallCheck(this, D3ReactForce);

    var _this = _possibleConstructorReturn(this, (D3ReactForce.__proto__ || Object.getPrototypeOf(D3ReactForce)).call(this, props));

    _initialiseProps.call(_this);

    var nodes = props.nodes,
        links = props.links,
        simulation = props.simulation;

    _this.force = new _simulation2.default(props, simulation);
    _this.force.setNodesLinks(nodes, links);
    return _this;
  } // 保存节点的包裹节点的dom，直接存this下的话react可能有bug，取不到
  // 保存边的dom


  _createClass(D3ReactForce, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.staticLayout) {
        var _props = this.props,
            _props$dragEvent = _props.dragEvent,
            dragEvent = _props$dragEvent === undefined ? {} : _props$dragEvent,
            _props$zoomEvent = _props.zoomEvent,
            zoomEvent = _props$zoomEvent === undefined ? {} : _props$zoomEvent,
            scaleExtent = _props.scaleExtent;

        this.force.initZoom({
          start: zoomEvent.start,
          isZoom: zoomEvent.isZoom,
          zoom: function zoom(transform) {
            (0, _d3Selection.select)(_this2.mainDom.outg).attr('transform', 'translate(' + transform.translate + ')scale(' + transform.scale + ')');
            zoomEvent.zoom && zoomEvent.zoom(transform);
          },
          end: zoomEvent.end
        }, scaleExtent);
        (0, _d3Selection.select)(this.mainDom.svg).call(this.force.zoom).on('dblclick.zoom', null);
        this.force.initDrag(dragEvent);
      }
      this.force.tick({
        tick: this.tick,
        end: this.props.end
      });
      this.setState({ init: true }); // 解决初始化有nodes时 node先渲染，取不到this.drap问题
    }

    // 居中


    // 执行里导向布局，直至静止

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nodes = nextProps.nodes,
          links = nextProps.links;

      this.force.setSimulationLayout(nextProps);
      this.force.setNodesLinks(nodes, links);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          width = _props2.width,
          height = _props2.height,
          nodeIdKey = _props2.nodeIdKey,
          staticLayout = _props2.staticLayout,
          svgProps = _props2.svgProps,
          outgProps = _props2.outgProps;
      var _force = this.force,
          translate = _force.translate,
          scale = _force.scale,
          nodes = _force.nodes,
          links = _force.links;

      if (staticLayout) {
        var getStaticLayoutTransform = this.getStaticLayoutTransform();
        width = getStaticLayoutTransform.width;
        height = getStaticLayoutTransform.height;
        translate = getStaticLayoutTransform.translate;
        scale = getStaticLayoutTransform.scale;
      }
      return _react2.default.createElement(
        'svg',
        _extends({ xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', ref: function ref(svg) {
            return _this3.mainDom.svg = svg;
          }, width: width, height: height }, svgProps),
        _react2.default.createElement(
          'g',
          _extends({ ref: function ref(outg) {
              return _this3.mainDom.outg = outg;
            }, transform: 'translate(' + translate + ')scale(' + scale + ')' }, outgProps),
          this.state.init || staticLayout ? [_react2.default.createElement(
            'g',
            { key: 'nodes' },
            links.map(function (link, i) {
              var key = link.source[nodeIdKey] + '_' + link.target[nodeIdKey];
              return _react2.default.createElement(_link2.default, { key: key, parentComponent: _this3, addRef: function addRef(c) {
                  _this3.linksDom[key] = c;
                }, addHoverRef: function addHoverRef(c) {
                  _this3.hoverLinksDom[key] = c;
                }, link: link });
            })
          ), _react2.default.createElement(
            'g',
            { key: 'links' },
            nodes.map(function (node, i) {
              var key = node[nodeIdKey];
              return _react2.default.createElement(_node2.default, { key: key, parentComponent: _this3, addRef: function addRef(c) {
                  _this3.nodesDom[key] = c;
                }, node: node });
            })
          )] : null,
          this.props.children
        )
      );
    }
  }]);

  return D3ReactForce;
}(_react2.default.Component);

D3ReactForce.defaultProps = {
  nodes: [],
  links: [],
  width: _default.WIDTH,
  height: _default.HEIGHT,
  nodeIdKey: _default.NODE_ID_KEY,
  velocityDecay: _default.VELOCITY_DECAY,
  linkDistance: _default.LINK_DISTANCE,
  collideRadius: _default.COLLIDE_RADIUS,
  collideStrength: _default.COLLIDE_STRENGTH,
  chargeStrength: _default.CHARGE_STRENGTH,
  staticLayout: false,
  XYCenter: _default.XY_CENTER,
  nodeClick: _default.noop,
  nodeDbClick: _default.noop,
  nodeMouseover: _default.noop,
  nodeMouseout: _default.noop,
  linkClick: _default.noop,
  linkMouseover: _default.noop,
  linkMouseout: _default.noop,
  tick: _default.noop,
  end: _default.noop,
  duration: 500,
  hasHoverLink: true
};

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.nodesDom = {};
  this.linksDom = {};
  this.hoverLinksDom = {};
  this.mainDom = {};
  this.state = {
    init: false
  };

  this.tick = function (alpha) {
    var _props3 = _this4.props,
        tick = _props3.tick,
        staticLayout = _props3.staticLayout;
    var _force2 = _this4.force,
        nodes = _force2.nodes,
        links = _force2.links;

    if (tick) {
      tick(alpha, {
        nodes: nodes,
        links: links,
        nodesDom: _this4.nodesDom,
        linksDom: _this4.linksDom
      });
    }
    if (!staticLayout) {
      nodes.forEach(function (node) {
        return _this4.nodeTick(node);
      });
      links.forEach(function (link) {
        return _this4.linkTick(link);
      });
    }
  };

  this.linkTick = function (link) {
    var animation = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var force = _this4.force,
        props = _this4.props;
    var nodeIdKey = props.nodeIdKey,
        hasHoverLink = props.hasHoverLink,
        duration = props.duration;

    var linkDom = (0, _d3Selection.select)(_this4.linksDom[link.source[nodeIdKey] + '_' + link.target[nodeIdKey]]);
    if (animation) linkDom = linkDom.transition().duration(duration);
    linkDom.attr('x1', function () {
      return force.nodesMap[link.source[nodeIdKey]].x;
    }).attr('y1', function () {
      return force.nodesMap[link.source[nodeIdKey]].y;
    }).attr('x2', function () {
      return force.nodesMap[link.target[nodeIdKey]].x;
    }).attr('y2', function () {
      return force.nodesMap[link.target[nodeIdKey]].y;
    });
    if (hasHoverLink) {
      var hoverLinkDom = (0, _d3Selection.select)(_this4.hoverLinksDom[link.source[nodeIdKey] + '_' + link.target[nodeIdKey]]);
      if (animation) hoverLinkDom = hoverLinkDom.transition().duration(duration);
      hoverLinkDom.attr('x1', function () {
        return force.nodesMap[link.source[nodeIdKey]].x;
      }).attr('y1', function () {
        return force.nodesMap[link.source[nodeIdKey]].y;
      }).attr('x2', function () {
        return force.nodesMap[link.target[nodeIdKey]].x;
      }).attr('y2', function () {
        return force.nodesMap[link.target[nodeIdKey]].y;
      });
    }
  };

  this.nodeTick = function (node) {
    var animation = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var _props4 = _this4.props,
        nodeIdKey = _props4.nodeIdKey,
        duration = _props4.duration;

    var nodeDom = (0, _d3Selection.select)(_this4.nodesDom[node[nodeIdKey]]);
    if (animation) nodeDom = nodeDom.transition().duration(duration);
    nodeDom.attr('transform', function () {
      return 'translate(' + node.x + ',' + node.y + ')';
    });
  };

  this.free = function () {
    _this4.force.nodes.forEach(function (node) {
      return node.fx = node.fy = null;
    });
    _this4.force.simulation.alpha(1).restart();
  };

  this.addLayout = function (layout) {
    var _options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _Layout = _layout3.default[layout];
    if (_Layout) {
      var _props5 = _this4.props,
          width = _props5.width,
          height = _props5.height;

      var options = Object.assign({ width: width, height: height }, _options);
      _this4[layout + 'Layout'] = new _Layout(options, _this4.force);
      return {
        execute: _this4.executeLayout.bind(_this4, layout)
      };
    } else {
      throw new Error('Can not find the layout of ' + layout);
    }
  };

  this.executeLayout = function (layout) {
    var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _layout = _this4[layout + 'Layout'];
    if (_layout) {
      _this4.forceEndTick();
      setTimeout(function () {
        // 解决tick直接更新dom的x、y问题
        _layout.execute(event);
        _this4.transformPosition();
        _this4.adaption(true);
      }, 100);
    }
  };

  this.adaption = function () {
    var animation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    var padding = 20;
    var _props6 = _this4.props,
        width = _props6.width,
        height = _props6.height,
        duration = _props6.duration;
    var nodes = _this4.force.nodes;

    var minX = 0,
        minY = 0,
        maxX = 0,
        maxY = 0;
    if (nodes.length) {
      minX = (0, _minBy3.default)(nodes, 'x').x;
      minY = (0, _minBy3.default)(nodes, 'y').y;
      maxX = (0, _maxBy3.default)(nodes, 'x').x;
      maxY = (0, _maxBy3.default)(nodes, 'y').y;
    }
    var offset = {
      width: maxX - minX,
      height: maxY - minY,
      x: minX,
      y: minY
    };
    var factor = 1,
        translateX = 0,
        translateY = 0;
    if (offset.width > width - padding || offset.height > height - padding) {
      if (offset.width / width > offset.height / height) {
        factor = (width - padding) / offset.width;
      } else {
        factor = (height - padding) / offset.height;
      }
    }
    translateX = width / 2 - minX * factor - offset.width / 2 * factor;
    translateY = height / 2 - minY * factor - offset.height / 2 * factor;
    if (animation) {
      (0, _d3Selection.select)(_this4.mainDom.outg).transition().duration(duration).attr('transform', 'translate(' + [translateX, translateY] + ')scale(' + factor + ')');
      setTimeout(function () {
        _this4.force.zoom.transform((0, _d3Selection.select)(_this4.mainDom.svg), _d3Zoom.zoomIdentity.translate(translateX, translateY).scale(factor));
      }, duration);
    } else {
      _this4.force.zoom.transform((0, _d3Selection.select)(_this4.mainDom.svg), _d3Zoom.zoomIdentity.translate(translateX, translateY).scale(factor));
    }
  };

  this.execute = function () {
    return _this4.force.execute();
  };

  this.originTransform = function (dom, transform) {
    _this4.force.zoom.transform(dom, transform);
  };

  this.transform = function (translate, scale, animation) {
    var duration = _this4.props.duration;

    if (!translate && !scale) {
      return {
        translate: _this4.force.translate,
        scale: _this4.force.scale
      };
    } else {
      var _zoomIdentity = _d3Zoom.zoomIdentity.translate.apply(_d3Zoom.zoomIdentity, _toConsumableArray(translate)).scale(scale);
      if (animation) {
        (0, _d3Selection.select)(_this4.mainDom.outg).transition().duration(duration).attr('transform', 'translate(' + translate + ')scale(' + scale + ')');
        setTimeout(function () {
          _this4.originTransform((0, _d3Selection.select)(_this4.mainDom.svg), _zoomIdentity);
        }, duration);
      } else {
        _this4.originTransform((0, _d3Selection.select)(_this4.mainDom.svg), _zoomIdentity);
      }
    }
  };

  this.zoom = function (_scale) {
    var _force3 = _this4.force,
        translate = _force3.translate,
        scale = _force3.scale;

    var _zoomIdentity = _d3Zoom.zoomIdentity.translate.apply(_d3Zoom.zoomIdentity, _toConsumableArray(translate)).scale(_scale * scale);
    _this4.originTransform((0, _d3Selection.select)(_this4.mainDom.svg), _zoomIdentity);
  };

  this.transformPosition = function () {
    var _force4 = _this4.force,
        nodes = _force4.nodes,
        links = _force4.links;

    nodes.forEach(function (node) {
      return _this4.nodeTick(node, true);
    });
    links.forEach(function (link) {
      return _this4.linkTick(link, true);
    });
  };

  this.forceEndTick = function () {
    var alphaTarget = _this4.force.simulation.alphaTarget();
    _this4.force.simulation.alphaTarget(alphaTarget).alpha(alphaTarget);
  };

  this.getStaticLayoutTransform = function () {
    var _props7 = _this4.props,
        nodes = _props7.nodes,
        width = _props7.width,
        padding = _props7.padding;

    var nodesX = nodes.map(function (node) {
      return node.x;
    });
    var nodesY = nodes.map(function (node) {
      return node.y;
    });
    var minX = Math.min.apply(Math, _toConsumableArray(nodesX)),
        minY = Math.min.apply(Math, _toConsumableArray(nodesY)),
        maxX = Math.max.apply(Math, _toConsumableArray(nodesX)),
        maxY = Math.max.apply(Math, _toConsumableArray(nodesY));
    var graphWidth = maxX - minX,
        graphHeight = maxY - minY;
    var scale = width > graphWidth ? 1 : width / graphWidth;
    var translateX = scale * minX,
        translateY = scale * minY;
    return {
      width: graphWidth * scale + 2 * padding,
      height: graphHeight * scale + 2 * padding,
      translate: [-translateX + padding, -translateY + padding],
      scale: scale,
      graphWidth: graphWidth,
      graphHeight: graphHeight
    };
  };
};

D3ReactForce.Simulation = _simulation2.default;
D3ReactForce.Node = _node2.default;
D3ReactForce.Link = _link2.default;
exports.default = D3ReactForce;
//# sourceMappingURL=index.js.map