'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
/**
 * @fileOverview 阿基米德螺线布局
 * https://zh.wikipedia.org/wiki/%E9%98%BF%E5%9F%BA%E7%B1%B3%E5%BE%B7%E8%9E%BA%E7%BA%BF
 * @author can.yang
 */


var ArchimeddeanSpiral = function (_Base) {
  _inherits(ArchimeddeanSpiral, _Base);

  function ArchimeddeanSpiral(options, simulation) {
    _classCallCheck(this, ArchimeddeanSpiral);

    var _this = _possibleConstructorReturn(this, (ArchimeddeanSpiral.__proto__ || Object.getPrototypeOf(ArchimeddeanSpiral)).call(this, options, simulation));

    Object.assign(_this, {
      /**
       * 宽
       * @type  {number}
       */
      width: null,

      /**
       * 高
       * @type  {number}
       */
      height: null,

      /**
       * 图中心
       * @type  {object}
       */
      center: null,

      /**
       * 参数 a
       * @type  {number}
       */
      a: 20,

      /**
       * 参数 b
       * @type  {number}
       */
      b: 15,

      /**
       * 最大角度
       * @type  {number}
       */
      maxAngle: 12 * Math.PI
    }, options);
    return _this;
  }
  // 执行布局


  _createClass(ArchimeddeanSpiral, [{
    key: 'execute',
    value: function execute(_ref) {
      var _ref$beforeExecute = _ref.beforeExecute,
          beforeExecute = _ref$beforeExecute === undefined ? function () {} : _ref$beforeExecute;
      var nodes = this.simulation.nodes;
      var a = this.a,
          b = this.b,
          maxAngle = this.maxAngle;

      var width = this.width;
      var height = this.height;
      var center = this.center ? this.center : {
        x: width / 2,
        y: height / 2
      };
      var l = nodes.length;
      var angleStep = maxAngle / l;
      var getAngle = function getAngle(i) {
        return i * angleStep;
      };
      var getRadius = function getRadius(angle) {
        return a + b * angle;
      };
      this.sort && nodes.sort(this.sort);
      this.simulation.nodes = nodes;
      beforeExecute && beforeExecute(nodes);
      nodes.forEach(function (node, i) {
        var angle = getAngle(i);
        var radius = getRadius(angle);
        node.fx = node.x = center.x + radius * Math.cos(angle);
        node.fy = node.y = center.y + radius * Math.sin(angle);
      });
    }
  }]);

  return ArchimeddeanSpiral;
}(_base2.default);

exports.default = ArchimeddeanSpiral;
//# sourceMappingURL=archimeddeanSpiral.js.map