'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _is = require('./is');

var _is2 = _interopRequireDefault(_is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 圆形布局
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author can.yang
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Circle = function (_Base) {
  _inherits(Circle, _Base);

  /**
   * 是否避免重叠
   * @type  {boolean}
   */
  function Circle(options, simulation) {
    _classCallCheck(this, Circle);

    var _this = _possibleConstructorReturn(this, (Circle.__proto__ || Object.getPrototypeOf(Circle)).call(this, options, simulation));

    _this.clockwise = true;
    _this.startAngle = 3 / 2 * Math.PI;

    if (!_is2.default.nil(options.clockwise)) {
      _this.clockwise = options.clockwise;
    }
    if (!_is2.default.nil(options.startAngle)) {
      _this.startAngle = options.startAngle;
    }
    if (!_is2.default.nil(options.sort)) {
      _this.sort = options.sort;
    }
    if (!_is2.default.nil(options.center)) {
      _this.center = options.center;
    }
    return _this;
  }
  /**
   * 起始角度
   * @type  {boolean}
   */


  _createClass(Circle, [{
    key: 'execute',
    value: function execute(_ref) {
      var _this2 = this;

      var _ref$beforeExecute = _ref.beforeExecute,
          beforeExecute = _ref$beforeExecute === undefined ? function () {} : _ref$beforeExecute;
      var _simulation = this.simulation,
          nodes = _simulation.nodes,
          links = _simulation.links;

      var radius = void 0;
      if (nodes.length <= 1) {
        radius = 0;
      } else {
        radius = Math.min(this.width, this.height) / 2;
      }
      var center = this.center ? this.center : {
        x: this.width / 2,
        y: this.height / 2
      };
      var angleStep = 2 * Math.PI / nodes.length;
      this.sort && nodes.sort(this.sort);
      beforeExecute && beforeExecute(nodes);
      nodes.forEach(function (node, i) {
        var theta = _this2.startAngle + i * angleStep * (_this2.clockwise ? 1 : -1);
        var rx = radius * Math.cos(theta);
        var ry = radius * Math.sin(theta);
        node.fx = node.x = center.x + rx;
        node.fy = node.y = center.y + ry;
      });
    }
  }]);

  return Circle;
}(_base2.default);

exports.default = Circle;
//# sourceMappingURL=circle.js.map