'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _dagre = require('dagre');

var _dagre2 = _interopRequireDefault(_dagre);

var _is = require('./is');

var _is2 = _interopRequireDefault(_is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 分层布局
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://github.com/dagrejs/dagre/wiki
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author can.yang
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Dagre = function (_Base) {
  _inherits(Dagre, _Base);

  function Dagre(options, simulation) {
    _classCallCheck(this, Dagre);

    var _this = _possibleConstructorReturn(this, (Dagre.__proto__ || Object.getPrototypeOf(Dagre)).call(this, options, simulation));

    Object.assign(_this, {
      rankdir: 'TB',
      align: undefined,
      nodesep: 50,
      edgesep: 10,
      ranksep: 50,
      marginx: 0,
      marginy: 0,
      acyclicer: undefined,
      useEdgeControlPoint: true,
      ranker: 'network-simplex',
      callback: null,
      nodeWidth: 20,
      nodeHeight: 20
    }, options);
    return _this;
  }

  _createClass(Dagre, [{
    key: 'getValue',
    value: function getValue(name) {
      var value = this[name];
      if (_is2.default.Function(value)) {
        return value();
      }
      return value;
    }
    // 执行布局

  }, {
    key: 'execute',
    value: function execute() {
      var _this2 = this;

      var _simulation = this.simulation,
          nodes = _simulation.nodes,
          links = _simulation.links,
          nodeIdKey = _simulation.nodeIdKey,
          sourceKey = _simulation.sourceKey,
          targetKey = _simulation.targetKey,
          nodesMap = _simulation.nodesMap;

      var nodeMap = {};
      var g = new _dagre2.default.graphlib.Graph();
      var useEdgeControlPoint = this.useEdgeControlPoint;
      g.setGraph({
        rankdir: this.getValue('rankdir'),
        align: this.getValue('align'),
        nodesep: this.getValue('nodesep'),
        edgesep: this.getValue('edgesep'),
        ranksep: this.getValue('ranksep'),
        marginx: this.getValue('marginx'),
        marginy: this.getValue('marginy'),
        acyclicer: this.getValue('acyclicer'),
        ranker: this.getValue('ranker')
      });
      g.setDefaultEdgeLabel(function () {
        return {};
      });
      nodes.forEach(function (node) {
        g.setNode(node[nodeIdKey], { width: _this2.nodeWidth, height: _this2.nodeHeight });
        nodeMap[node[nodeIdKey]] = node;
      });
      links.forEach(function (link) {
        var source = link.source[nodeIdKey],
            target = link.target[nodeIdKey];
        g.setEdge(source, target);
      });
      _dagre2.default.layout(g);
      g.nodes().forEach(function (v) {
        var node = g.node(v);
        nodeMap[v].fx = nodeMap[v].x = node.x;
        nodeMap[v].fy = nodeMap[v].y = node.y;
      });
      g.edges().forEach(function (e, i) {
        var edge = g.edge(e);
        if (useEdgeControlPoint) {
          links[i].controlPoints = edge.points.slice(1, edge.points.length - 1);
        }
      });
    }
  }]);

  return Dagre;
}(_base2.default);

exports.default = Dagre;
//# sourceMappingURL=dagre.js.map