'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d3Selection = require('d3-selection');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Link = function (_React$Component) {
  _inherits(Link, _React$Component);

  function Link() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Link);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Link.__proto__ || Object.getPrototypeOf(Link)).call.apply(_ref, [this].concat(args))), _this), _this.componentDidMount = function () {
      var _this$props = _this.props,
          link = _this$props.link,
          parentComponent = _this$props.parentComponent;

      _this._link.__data__ = link;
      var _parentComponent$prop = parentComponent.props,
          linkClick = _parentComponent$prop.linkClick,
          linkMouseover = _parentComponent$prop.linkMouseover,
          linkMouseout = _parentComponent$prop.linkMouseout,
          hasHoverLink = _parentComponent$prop.hasHoverLink;

      (0, _d3Selection.select)(hasHoverLink ? _this._hover_link : _this._link).on('click', function () {
        linkClick.call(_this, _this.props.link, _d3Selection.event);
      }).on('mouseover', function () {
        linkMouseover.call(_this, _this.props.link, _d3Selection.event);
      }).on('mouseout', function () {
        linkMouseout.call(_this, _this.props.link, _d3Selection.event);
      });
    }, _this.saveRef = function (child) {
      var addRef = _this.props.addRef;

      addRef(child);
      _this._link = child;
    }, _this.saveHoverLinkRef = function (child) {
      var addHoverRef = _this.props.addHoverRef;

      _this._hover_link = child;
      addHoverRef(child);
    }, _this.getBaseProps = function () {
      var link = _this.props.link;

      var baseProps = {
        link: link,
        x1: link.source.x,
        y1: link.source.y,
        x2: link.target.x,
        y2: link.target.y
      };
      return baseProps;
    }, _this.getObjectProps = function (object) {
      var link = _this.props.link;

      var arrts = {};
      Object.keys(object || {}).forEach(function (attr) {
        arrts[attr] = typeof object[attr] === 'function' ? object[attr](link) : object[attr];
      });
      return arrts;
    }, _this.getLinkJsx = function () {
      var _this$props2 = _this.props,
          addRef = _this$props2.addRef,
          parentComponent = _this$props2.parentComponent;
      var linkElement = parentComponent.props.linkElement;

      var baseProps = _this.getBaseProps();
      var linkProps = _extends({
        ref: _this.saveRef
      }, baseProps);
      if (typeof linkElement === 'function') {
        return _react2.default.cloneElement(linkElement(link), linkProps);
      } else if (_react2.default.isValidElement(linkElement)) {
        var ref = linkProps.ref,
            nestProps = _objectWithoutProperties(linkProps, ['ref']);

        return _react2.default.cloneElement(linkElement, _extends({}, nestProps, { addRef: _this.saveRef }));
      } else if ((typeof linkElement === 'undefined' ? 'undefined' : _typeof(linkElement)) === 'object' || !linkElement) {
        var linkAttrs = _this.getObjectProps(linkElement);
        return _react2.default.createElement('line', _extends({
          stroke: '#999',
          strokeWidth: '1'
        }, linkAttrs, linkProps));
      } else {
        throw new Error('prop linkElement isValid');
      }
    }, _this.getHoverLink = function () {
      var _this$props3 = _this.props,
          parentComponent = _this$props3.parentComponent,
          addHoverRef = _this$props3.addHoverRef;

      var baseProps = _this.getBaseProps();
      var _parentComponent$prop2 = parentComponent.props.hoverLink,
          hoverLink = _parentComponent$prop2 === undefined ? {} : _parentComponent$prop2;

      var hoverLinkAttrs = _this.getObjectProps(hoverLink);
      return _react2.default.createElement('line', _extends({
        ref: _this.saveHoverLinkRef,
        stroke: '#fff',
        strokeWidth: '4',
        opacity: '0'
      }, hoverLinkAttrs, baseProps));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Link, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this._link.__data__ = nextProps.link;
    }
  }, {
    key: 'render',
    value: function render() {
      var hasHoverLink = this.props.hasHoverLink;

      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        this.getLinkJsx(),
        !!hasHoverLink && this.getHoverLink()
      );
    }
  }]);

  return Link;
}(_react2.default.Component);

exports.default = Link;
//# sourceMappingURL=link.js.map