'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d3Selection = require('d3-selection');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Node = function (_React$Component) {
  _inherits(Node, _React$Component);

  function Node() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Node);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Node.__proto__ || Object.getPrototypeOf(Node)).call.apply(_ref, [this].concat(args))), _this), _this.initEvent = function (props) {
      var node = props.node,
          parentComponent = props.parentComponent;

      _this._node.__data__ = node;
      (0, _d3Selection.select)(_this._node).on('click', function (d) {
        var event = _d3Selection.event;
        event.stopPropagation();
        var _parentComponent$prop = parentComponent.props,
            nodeClick = _parentComponent$prop.nodeClick,
            nodeDbClick = _parentComponent$prop.nodeDbClick;

        if (d._clickid) {
          clearTimeout(d._clickid);
          d._clickid = null;
          nodeClick.call(_this, d, event);
          nodeDbClick.call(_this, d, event);
        } else {
          d._clickid = setTimeout(function () {
            nodeClick(d, event);
            d._clickid = null;
          }, 300);
        }
      }).on('mouseover', function (node) {
        var nodeMouseover = parentComponent.props.nodeMouseover;

        nodeMouseover.call(_this, node, _d3Selection.event);
      }).on('mouseout', function (node) {
        var nodeMouseout = parentComponent.props.nodeMouseout;

        nodeMouseout.call(_this, node, _d3Selection.event);
      }).call(parentComponent.force.drag).on('mouseover.force', null).on('mouseout.force', null);
    }, _this.getNode = function () {
      var _this$props = _this.props,
          node = _this$props.node,
          parentComponent = _this$props.parentComponent;
      var nodeElement = parentComponent.props.nodeElement;

      if (nodeElement) {
        if (typeof nodeElement === 'function') {
          return nodeElement(node);
        } else if (_react2.default.isValidElement(nodeElement)) {
          return _react2.default.cloneElement(nodeElement, { node: node });
        } else {
          throw new Error('prop nodeElement isValid');
        }
      }
      return _react2.default.createElement('circle', { cx: '0', cy: '0', r: '10', strokeWidth: '1', stroke: '#4098e2', fill: '#4098e2' });
    }, _this.saveRef = function (child) {
      _this._node = child;
      _this.props.addRef(child);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Node, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this._node.__data__ = nextProps.node; // 解决导入操作记录时候因为图上节点已存在引用变化的问题
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initEvent(this.props);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          node = _props.node,
          parentComponent = _props.parentComponent;
      var _parentComponent$prop2 = parentComponent.props,
          nodeIdKey = _parentComponent$prop2.nodeIdKey,
          width = _parentComponent$prop2.width,
          height = _parentComponent$prop2.height,
          nodeProps = _parentComponent$prop2.nodeProps;

      return _react2.default.createElement(
        'g',
        _extends({ ref: this.saveRef
        }, nodeProps, {
          transform: 'translate(' + (node.x || width / 2) + ',' + (node.y || height / 2) + ')'
        }),
        _react2.default.createElement(
          'g',
          { id: node[nodeIdKey] },
          this.getNode()
        )
      );
    }
  }]);

  return Node;
}(_react2.default.Component);

exports.default = Node;
//# sourceMappingURL=node.js.map